'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var hash, compress, plugins, dll, devtool, cssFileName, commonName;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new _plugins.FriendlyErrorsWebpackPlugin({
              onErrors: function onErrors(severity, errors) {
                if (severity !== 'error') {
                  _util.notifier.notify({
                    title: 'hollow cli',
                    message: 'warn',
                    contentImage: _path2.default.join(__dirname, '../assets/warn.png'),
                    sound: 'Glass'
                  });
                  return;
                }
                var error = errors[0];
                _util.notifier.notify({
                  title: 'hollow cli',
                  message: severity + ' : ' + (error ? error.name : error),
                  subtitle: error ? error.file : error || '',
                  contentImage: _path2.default.join(__dirname, '../assets/fail.png'),
                  sound: 'Glass'
                });
              }
            }), new _plugins.ProgressPlugin(_util.fnProgressHandler), new _plugins.NoEmitOnErrorsPlugin(), new _plugins.ModuleConcatenationPlugin(), //scope hoisting
            new _plugins.HashedModuleIdsPlugin()];

            next();

            hash = context.hash, compress = context.compress, plugins = context.plugins, dll = context.dll, devtool = context.devtool;
            cssFileName = hash ? '[name]-[chunkhash].css' : '[name].css';
            commonName = hash ? 'common-[chunkhash].js' : 'common.js';


            if (!Array.isArray(dll)) {

              plugins.push(new _plugins.CommonsChunkPlugin({
                name: 'common',
                filename: commonName,
                minChunks: 2
              }));

              //split import() and require.ensure modules common chunks
              plugins.push(new _plugins.CommonsChunkPlugin({
                async: true,
                minChunks: function minChunks(module, count) {
                  if (module.resource && /^.*\.(css|less)$/.test(module.resource)) {
                    return false;
                  }
                  return !!module.context && count >= 2;
                }
              }));
            }

            plugins.push(new _plugins.ExtractTextPlugin({
              filename: cssFileName,
              allChunks: true
            }));

            if (compress === true) {
              plugins.push(new _plugins.UglifyJsPlugin({
                parallel: true,
                cache: true,
                sourceMap: !!devtool
              }));
            }

            context.plugins = plugins;

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}(); /**************************************************
      * Created by nanyuantingfeng on 27/10/2017 16:25.
      **************************************************/


module.exports = exports['default'];